<?php
/**
 * IMPORTANT NOTE
 * The code of this system is closed and a private proprietary of Flex Solutions.
 * A written authorization/license from Flex Solutions is required before using or modifying this code.
 * Email: sales@flexsolution.biz, Phone: +962795342585, Website: http://www.flexsolutions.biz
 */
 
/**
 * This is the model class for table "tid_detailed_dashboard".
 *
 * The followings are the available columns in table 'tid_detailed_dashboard':
 * @property integer $id
 * @property string $date
 * @property integer $segment_id
 * @property string $segment_name
 * @property integer $tid_id
 * @property integer $tid_status_id
 * @property string $status
 * @property integer $renewal_stage_id
 * @property integer $grace_period
 * @property integer $days_count
 * @property double $fine
 *
 * The followings are the available model relations:
 * @property Segment $segment
 * @property TidStatus $tidStatus
 * @property RenewalStage $renewalStage
 * @property Tid $tid
 */
class TidDetailedDashboard extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'tid_detailed_dashboard';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('date, segment_name, tid_id, tid_status_id', 'required'),
			array('segment_id, tid_id, tid_status_id, renewal_stage_id, grace_period, days_count', 'numerical', 'integerOnly'=>true),
			array('fine', 'numerical'),
			array('segment_name', 'length', 'max'=>500),
			array('status', 'length', 'max'=>18),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('id, date, segment_id, segment_name, tid_id, tid_status_id, status, renewal_stage_id, grace_period, days_count, fine', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
			'segment' => array(self::BELONGS_TO, 'Segment', 'segment_id'),
			'tidStatus' => array(self::BELONGS_TO, 'TidStatus', 'tid_status_id'),
			'renewalStage' => array(self::BELONGS_TO, 'RenewalStage', 'renewal_stage_id'),
			'tid' => array(self::BELONGS_TO, 'Tid', 'tid_id'),
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'id' => 'ID',
			'date' => Yii::t('default', 'Date'),
			'segment_id' =>  Yii::t('default','Segment'),
			'segment_name' =>  Yii::t('default','Segment Name'),
			'tid_id' =>  Yii::t('default','Tid'),
			'tid_status_id' =>  Yii::t('default','Tid Status'),
			'status' => Yii::t('default','Status'),
			'renewal_stage_id' =>  Yii::t('default','Processing Stage'),
			'grace_period' =>  Yii::t('default','Days to Expire'),
			'days_count' =>  Yii::t('default','Days Count'),
			'fine' =>  Yii::t('default','Fine'),
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('id',$this->id);
		$criteria->compare('date',$this->date,true);
		$criteria->compare('segment_id',$this->segment_id);
		$criteria->compare('segment_name',$this->segment_name,true);
		$criteria->compare('tid_id',$this->tid_id);
		$criteria->compare('tid_status_id',$this->tid_status_id);
		$criteria->compare('status',$this->status,true);
		$criteria->compare('renewal_stage_id',$this->renewal_stage_id);
		$criteria->compare('grace_period',$this->grace_period);
		$criteria->compare('days_count',$this->days_count);
		$criteria->compare('fine',$this->fine);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return TidDetailedDashboard the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
